/*
 * Test for a bug in enqueue function
 * Author: Catalin(ux) M. BOIE
 */
#define _GNU_SOURCE

#include <Conn.h>


static void c_connected(struct Conn *C)
{
	char buf[70];

	memset(buf, 0, sizeof(buf));

	Conn_enqueue(C, buf, 70);
	Conn_enqueue(C, buf, 70);
	Conn_enqueue(C, buf, 70);
	Conn_enqueue(C, buf, 70);
	Conn_close(C);
}

int main(void)
{
	int ret;
	struct Conn *C;

	Conn_debug(NULL, 10);

	Conn_default_ibuf = 128;
	Conn_default_obuf = 128;

	ret = Conn_init(0);
	if (ret == -1) {
		printf("%s\n", Conn_strerror());
		return 1;
	}

	Conn_connected_cb = c_connected;

	C = Conn_alloc();
	if (!C) {
		printf("Error alloc Conn struct [%s]!\n",
			Conn_strerror());
		return 1;
	}

	Conn_set_socket_domain(C, PF_INET);
	Conn_set_socket_type(C, SOCK_STREAM);
	Conn_set_socket_addr(C, "www.66.com");
	Conn_set_socket_port(C, 80);
	ret = Conn_commit(C);
	if (ret != 0) {
		printf("Error commiting [%s]!\n",
			Conn_strerror());
		return 1;
	}

	while (1) {
		ret = Conn_poll(-1);
		if (ret == -1) {
			printf("Error in poll [%s]!\n",
				Conn_strerror());
			break;
		} else if (ret == 0)
			break;
	}

	printf("\n");

	Conn_shutdown();

	return 0;
}
