/*
 * Testing splitting functions
 */

#include <Conn.h>

int main(void)
{
	char *x;
	char A[4096];
	char s[8192];
	int ret = 0;
	struct Conn_split *sp;

	memset(A, 'A', sizeof(A));
	A[sizeof(A) - 1] = '\0';

	snprintf(s, sizeof(s), "a=b c= d= sasasasdasd=%s\r\n", A);

	sp = Conn_split(s);
	if (!sp) {
		printf("Cannot split (%s)!\n", Conn_strerror());
		ret++;
	} else {
		x = Conn_split_get(sp, "a");
		if (!x || strcmp(x, "b") != 0) {
			printf("ERROR: a != %s.\n", x);
			ret++;
		}

		x = Conn_split_get(sp, "c");
		if (!x || strcmp(x, "") != 0) {
			printf("ERROR: \"\" != \"%s\".\n", x);
			ret++;
		}
	}

	Conn_split_free(&sp);

	return ret;
}
